<?php
/*
Plugin Name: xxternal-rss
Plugin URI: http://www.pretzlaff.info/wp/wordpress-plugins/xxternal-rss
Description: Include external RSS-Feed into Page/Post per simple tag. Install, config and insert simple tag into your post or site, That's all
Version: 0.1.6
Author: Ruediger Pretzlaff
Author URI: http://www.pretzlaff.info
*/
# if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }

define('externalrssversion',  "0.1.6");
define('externalrssauthor',   "Ruediger Pretzlaff");
define('externalrssemail',    "ruediger@pretzlaff.info");
define('externalrssurl',      "http://www.pretzlaff.info/wp/wordpress-plugins/xxternal-rss/");
define('externalrssdate',     "Mi 19. Nov 12:24:29 CET 2008");
define('externalrssbuild',    "#117");

require_once(ABSPATH."wp-content/plugins/xxternal-rss/view.php");
require_once(ABSPATH."wp-content/plugins/xxternal-rss/extrss_options_page.php");

add_action('admin_menu', 'erss_admin_menu');
 
function erss_admin_menu()
{
  if (function_exists('add_menu_page')){
    add_menu_page('Xternal RSS', 'Xxternal RSS', 10, __FILE__, 'extrss_options_page');
    add_submenu_page(__FILE__, 'View', 'View', 8, 'view', 'erssview');
    add_submenu_page(__FILE__, 'About', 'About', 8, 'about', 'mt_sublevel_page2');
  }
}

function getthefeed($url,$count,$show_description) 
{
  $opt_name   = 'mt_favorite_food';
  $opt_name2  = 'mt_favorite_count';
  if ( $url == "" ) {
    $opt_val    = get_option( $opt_name );
  } else {
    $opt_val = $url;
  }
  if ( ! $count ) {
    $opt_val2 = get_option( $opt_name2 );
  } else {
    $opt_val2 = $count;
  }
  $newsurl    = $opt_val; 
  $number = $opt_val2; 
  $msg ="";
  if ( $show_description ) {
    $xhead_a= '<h3>';
    $xhead_b = '</h3>';
  } else {
    echo '<ul>';
    $xhead_a  = '<li>';
    $xhead_b  = '</li>';
    $ul_end = '</ul>';
  }
  $file_content = @file_get_contents($newsurl);
  $items = preg_match_all("/<item>(.*)<\/item>/Uis", $file_content, $array_items);
  $array_items = $array_items[1];
  if(!empty($array_items)) {
    $max=count($array_items);
    for( $n=0; $n<$number; $n++ ) {
      preg_match("/<link>(.*)<\/link>/Uis", $array_items[$n], $array_link);    
      preg_match("/<title>(.*)<\/title>/Uis", $array_items[$n], $array_title);
      $title = str_replace('<title>','',$array_title[0]); 
      $title = str_replace('</title>','',$title); 
      $link  = str_replace('<link>','',$array_link[0]); 
      $link  = str_replace('</link>','',$link); 
      $title = str_replace('amp;','',$title);
      $msg .= $xhead_a . "<a title=\"\" href=\"" . $link . "\" target=\"_blank\">" . $title . "</a>" . $xhead_b . " ";
      if($show_description ) {
        preg_match("/<description>(.*)<\/description>/Uis", $array_items[$n], $array_description);
        if(!empty($array_description[1])) {
        # $msg .= str_replace('[AUTOR]','<strong><em>',str_replace('[/AUTOR]','</em></strong>',htmlentities(str_replace('<![CDATA[','',str_replace(']]','',$array_description[1])))));
        $msg .= str_replace('[AUTOR]','<strong><em>',str_replace('[/AUTOR]','</em></strong>',str_replace('<![CDATA[','',str_replace(']]','',$array_description[1]))));
        }
      }
      if ( $show_description ) {
        $msg .= "<a title=\"Weiter lesen..\" href=\"". $link . "\" target=\"_blank\">Weiter lesen...</a>";
        $msg .= "<hr />";
      }
    }
    $msg .= $ul_end;
  } else { 
    $msg .= "Keine Meldungen"; 
  }
  return $msg;
}
function mt_sublevel_page2() {
    // Now display the options editing screen
    echo '<div class="wrap">';
    // header
    echo "<h2>" . __( 'Xxternal-RSS-Feed', 'mt_trans_domain' ) . "</h2>";

    echo "<h2>About</h2>";
    echo "<p>Xxternal-RSS Version: " . externalrssversion . "Build: " . externalrssbuild  . "</p>"; 
    echo "<p>Builddate: " . externalrssdate   . "</p>"; 
    echo "<p>Author:    " . externalrssauthor . "</p>"; 
    echo "<p>E-Mail:    <a href=\"mailto:" . externalrssemail . "\">" . externalrssemail . "</a></p>"; 
    echo "<p>Homepage:  <a href=\"" . externalrssurl . "\">" . externalrssurl . "</a></p>"; 
    echo "<hr>";
    echo "<h3>Usage:</h3>";
    echo "<p>Im Adminbreich Ihrer Wordpress Installation ist im Menü der Eintrag \"Xxternal-RSS\".";
    echo "Dort kann eine URL zu einem RSS-Feed eingtragen werden und die Anzahl der Einträge die aus diesem";
    echo "Feed angzeigt werden sollen.</p>";
    echo "<p>Der Feed kann dann mit folgender Zeile in jede Seite oder Blogeintrag eingefügt werden auf der er erscheinen soll:<p>";
    echo "<p><code class=\"prettyprint\">[rss=1,url=]</code></p>";
    echo "<p>Wenn ein anderer Feed benutzt werden soll, der nicht im Adminbereich eingetragen wurde, kann man machen mit:</p>";
    echo "<p><code class=\"prettyprint\">[rss=5,url=http://www.example.org/feed/]</code></p>";
    echo "<p>Dieser Eintrag zeigt die ersten 10 Einträge des Feeds von www.example.org an</p>";
    echo "</div>";
}

add_filter('the_content', 'getexternalfeedtags', 10);
add_filter('the_excerpt', 'getexternalfeedtags', 10);

function getexternalfeedtags($content) 
{
  if ( stristr( $content, '[rss' )) {

  $search = "@(?:<p>)*\s*\[rss\s*=\s*(\w+|^\+)(|,extend|,compact|,url=(.*))\]\s*(?:</p>)*@i";
  if  (preg_match_all($search, $content, $matches)) {
    if (is_array($matches)) {
      foreach ($matches[1] as $key =>$v1) {
        $search = $matches[0][$key];
        $count = $matches[1][$key];
        $url = $matches[2][$key];
        $urlb = str_replace(',url=','',$url);
        if ( $urlb == '' || $urlb == 'compact' ) {
          $count = '';
        }
        $show_description = 1; 
        $replace = getthefeed($urlb, $count, $show_description);
        $content= str_replace ($search, $replace, $content);
      }   
    }   
  }   
}
  return $content;
}


function xxternal_rss_widget_init() {

  // check for the required WP functions, die silently for pre-2.2 WP.
  if ( !function_exists('wp_register_sidebar_widget') )
    return;

  // front end view
  function xxternal_rss_widget($args) {
    extract($args);
    // the widget's form, themeable through $args
    $title = 'Xxternal-RSS';
    $show_description = false;
    echo $before_widget . $before_title . $title . $after_title;
    echo '<div style="margin-top:5px;">';
    echo getthefeed($url,$count,$show_description); 
    echo '</div>';
    echo $after_widget;
  }

  // back end controller
  function xxternal_rss_widget_control() {
    echo 'kommt noch, ganz sicher.';
  }

  // let WP know of this plugin's widget view entry
  wp_register_sidebar_widget('xxternal_rss_widget', 'Xxternal-RSS Widget', 
        'xxternal_rss_widget', 
       array(
          'classname' => 'xxternal_rss_widget', 
          'description' =>'Allows the user to add RSS-Feeds to sidebar'.
                    ' So der Plan ;-).',
      )
        );

  // let WP know of this widget's controller entry
  wp_register_widget_control('xxternal_rss_widget', 'Xxternal-RSS Widget', 
        'xxternal_rss_widget_control', 
      array(
          'width' => 300
      )
        );
}
function xxternal_rss_header()
{
  echo "\n\n        <meta name='Xxternal-RSS' content='" . externalrssversion . "' />";
  echo "\n        <meta name='Xxternal-RSS-Build' content='" . externalrssbuild . "' />";
  echo "\n        <meta name='Xxternal-RSS-URL' content='" . externalrssurl . "' />";
  echo "\n        <meta name='Xxternal-RSS-Author' content='" . externalrssauthor . "' />";
  echo "\n        <meta name='Xxternal-RSS-Builddate' content='" . externalrssdate . "' />\n\n";
}
add_action('widgets_init', 'xxternal_rss_widget_init');
add_action('wp_head', 'xxternal_rss_header');
?>
